# Copyright <2022> <Elizabeth Q Smith>
# Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files
# (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense,
# and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

# The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
# DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
# OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

import math
import scipy.special as special
import scipy.integrate as integrate
import numpy as np
import pandas as pd
import cmath as c
import time
import os
import matplotlib.pyplot as plt
import matplotlib.patches as mpatches


# file_location = 'C:/Users/lizqs/Documents/Research Grad School/Field Data/York 2021/July 20th/Sidescan'
# os.chdir(file_location)
# fid = ['Goodwin_337_7.5.smb','Goodwin_337_10.smb','Goodwin_337_15.smb','Goodwin_337_25.smb']

# file_location = 'C:/Users/lizqs/Documents/Research Grad School/Field Data/York 2021/July 19th/Sidescan'
# os.chdir(file_location)
# # fid = ['Jul19_2021_Site329_7.5.smb','Jul19_2021_Site330_7.5.smb','Jul19_2021_Site331_7.5.smb']
# fid = ['Jul19_2021_Site329_7.5.smb','Jul19_2021_Site329_10.smb','Jul19_2021_Site329_15.smb','Jul19_2021_Site329_25.smb']

# file_location = 'C:/Users/lizqs/Documents/Research Grad School/Field Data/Piankatank-2'
# os.chdir(file_location)
# fid = ['Oct26,2020,15-04-11.smb','Oct26,2020,15-09-23.smb']#,'Oct26,2020,15-15-20.smb','Oct26,2020,15-19-57.smb']
# fid = ['Oct26,2020,15-15-20.smb','Oct26,2020,15-04-11.smb','Oct26,2020,15-19-57.smb']
# fid = ['Oct26,2020,15-34-59.smb','Oct26,2020,15-39-57.smb','Oct26,2020,15-45-25.smb','Oct26,2020,15-04-11.smb']

# file_location = 'C:/Users/lizqs/Documents/Research Grad School/Field Data/New Hampshire/Adams_Pt_8_6'
# os.chdir(file_location)
# fid = ['Adams_site1_40gain_75_Wide.smb', 'Adams_site1_50gain_75.smb', 'Adams_site1_60gain_75.smb','Adams_site1_75gain_75.smb','Adams_site1_90gain_75.smb']
#fid = ['Adams_site1_40gain_75_Med.smb','Adams_site1_40gain_75_Narr.smb', 'Adams_site1_40gain_75_Wide.smb']
# fid = ['Adams_site1_40gain_75_900.smb','Adams_site1_40gain_75_1100.smb','Adams_site1_40gain_75_Med.smb']
# fid = ['Adams_site1_90gain_10.smb', 'Adams_site1_90gain_15.smb','Adams_site1_90gain_75.smb']

# file_location = 'C:/Users/lizqs/Documents/Research Grad School/Field Data/New Hampshire/Woody_Adams_8_6'
# os.chdir(file_location)
# fid = ['Woody_Adams_40gain_75.smb', 'Woody_Adams_50gain_75.smb', 'Woody_Adams_60gain_75.smb','Woody_Adams_75gain_75.smb']
# fid = ['Woody_Adams_90gain_75_Narr.smb','Woody_Adams_90gain_75_Med.smb','Woody_Adams_90gain_75.smb']
# fid = ['Woody_Adams_90gain_75_Med.smb', 'Woody_Adams_90gain_75_Med_900.smb', 'Woody_Adams_90gain_75_Med_1100.smb']

# file_location = 'C:/Users/lizqs/Documents/Research Grad School/Field Data/New Hampshire/Eliot site'
# os.chdir(file_location)
## NOTE: segment below two are very wavy
# fid = ['Elliot_50gain_75.smb','Elliot_60gain_75.smb','Elliot_75gain_75.smb','Elliot_90gain_75.smb']

### FOR MULTIPLE COMPARISONS
# constants: range = 7.5, bandwidth = medium, gain = 40%, freq = 1000 kHz
# filepath = ['C:/Users/lizqs/Documents/Research Grad School/Field Data/Piankatank-2','C:/Users/lizqs/Documents/Research Grad School/Field Data/New Hampshire/Adams_Pt_8_6']
# fid = ['Oct26,2020,15-04-11.smb','Adams_site1_40gain_75_Med.smb']
# constants: range = 7.5, bandwidth = Wide, gain = 90%, freq = 1000 kHz
filepath = ['C:/Users/lizqs/Documents/Research Grad School/Field Data/New Hampshire/Adams_Pt_8_6','C:/Users/lizqs/Documents/Research Grad School/Field Data/New Hampshire/Adams_8_7','C:/Users/lizqs/Documents/Research Grad School/Field Data/New Hampshire/Woody_Adams_8_6','C:/Users/lizqs/Documents/Research Grad School/Field Data/New Hampshire/Eliot site']
fid = ['Adams_site1_90gain_75.smb','Adams_8_7_90gain_75.smb','Woody_Adams_90gain_75.smb','Elliot_90gain_75.smb']

###FOR STATISTICAL ANALYSIS
# filepath = ['C:/Users/lizqs/Documents/Research Grad School/Field Data/Piankatank-2']
# fid = ['Oct26,2020,15-04-11.smb']



hi = 0

for name in fid:

    file_location = filepath[hi]
    os.chdir(file_location)

    string = "".join(['sonar_data', name, '.csv'])
    sonar_data = pd.read_csv(string, index_col=0)
    string2 = "".join(['settings', name, '.csv'])
    settings = pd.read_csv(string2, index_col=0)
    print(name)

    ## SONAR/WAVE PROPERTIES
    SL = 225  # [dB re 1 micropascal] ballpark estimate???
    height = 1.2  # [m]
    range = settings.loc[0,'Range']  # [m]
    print(f"range:{range}")

    # This will need to pull from a header data file- GAIN scale initial
    GainShiftFactor = settings.loc[0,'GainShiftFactor']
    if GainShiftFactor == 4:
        max_gain = 24 # [dB] high settings
    elif GainShiftFactor == 5:
        max_gain = 18 # [dB] medium setting
    elif GainShiftFactor == 6:
        max_gain = 12 # [dB] low setting
    else:
        print('WARNING: GainShiftFactor from Settings not within specified values, gain may not be calculated correctly')

    print(f"Max dB: {max_gain}")
    app_gain = settings.loc[0,'Gain'] # Gain applied to signal, 0 to 255
    p_Gain = app_gain/255  # [%] some percentage of max gain
    Gain = p_Gain * max_gain # [dB]
    Max_dB = Gain
    print(f"Percentage Gain:{p_Gain}")
    print(f"Max available dB:{Max_dB}")


    ## TVG SETTINGS [COULD USE THESE ON DATA OR ON MATHED DATA?]
    AutoTvg = settings.loc[0,'AutoTvg']
    if AutoTvg == 1:
        print('WARNING: Automatic Time Varying Gain Enabled, Tvg calculations may not be correct.')

    TvgFactorA = settings.loc[0,'TvgAFactor'] # [dB] represents spreading loss
    TvgFactorB = settings.loc[0,'TvgBFactor']   # [dB per kilometer] represents one way absorption loss
    TvgFactorC = settings.loc[0,'TvgCFactor']   # [dB] represents a base or starting gain level
    # TvgFactorK = 20 #[dB]
    TvgLimit = settings.loc[0,'TvgLimit']   # [Factor L in dB] limits the max gain to reasonable levels

    ### START LOOP!
    ## ANGLES
    Tot_gain = []
    count = 0
    spaces = len(sonar_data.columns)  # this is the amount of iterations (take it from spaces from smb_open_edits)
    print(f"columns:{spaces}")
    length = np.arange(0, range, (range / spaces))


    ## THIS SECTION WILL BUILD A DATAFRAME WITH STATISTICS OF EACH FID
    # Initialize variables
    lines = np.arange(5, 2750, 1).tolist()
    num = 0
    line_statistics_1 = pd.DataFrame()
    for line in lines:

        if len(sonar_data)-4 == line:
            break

        # Gets a single line from the sonar data
        line_data = sonar_data.iloc[line, 1:]
        Meas_Backscatter = sonar_data.iloc[line, 1:]
        # Meas_Backscatter = (Meas_Backscatter/255)*(Max_dB)
        Meas_Backscatter = Meas_Backscatter.tolist()
        line_statistics_1['Line Number'] = [line]


        # Cutoff value set at estimated value where the tripod has no more influence over the signal except in the leg
        # ie the value is found from the image set at a certain dip value
        if range == 7:  # this is really 7.5
            start = 230
        elif range == 10:
            start = 200
        elif range == 5:
            start = 230
        elif range == 20: # needs to be fixed
            start = 90
        elif range == 15:
            start = 150
        elif range == 25:
            start = 90
        else:
            print('WARNING: Range not in if statement, no cutoff value used.')

        # to correct for the rounding error:
        if range == 7:
            range = 7.5

        #finds the line numbers for the horizontal segments
        line_col = (478/range)*(np.arange(1,range,1))


        Meas_Backscatter = Meas_Backscatter[start:]
        # x_points = length[start:len(Theo_Backscatter)]
        # Theo_Backscatter = Theo_Backscatter[start:]

        # Begins to form dataframe "line_Statistics" with statistical data of that line
        m, b = np.polyfit(length[(start + 1):(len(length))], Meas_Backscatter, 1)
        line_statistics_1['Applied % Gain'] = [round(p_Gain,2)*100]
        line_statistics_1['Output Gain [dB]'] = [round(Max_dB,2)]
        line_statistics_1['length of data'] = [len(Meas_Backscatter)]
        line_statistics_1['Slope of Trendline'] = [m]
        line_statistics_1['y-int of Trendline'] = [b]
        line_statistics_1['Mean'] = [round(np.mean(Meas_Backscatter), 2)]
        line_statistics_1['Standard Deviation'] = [round(np.std(Meas_Backscatter), 2)]
        line_statistics_1['Range'] = [round(np.ptp(Meas_Backscatter), 2)]

        # # add in TVG settings to Empirical backscatter
        # Tot_gain = Tot_gain[1:]
        # Tot_gain = np.flip(Tot_gain)
        # Meas_Backscatter_g = Meas_Backscatter - Tot_gain

        # Average Empirical Data across multiple lines (rolling average accross lines)
        emp_subset = sonar_data.iloc[[line-4,line-3,line-2,line-1,line,line+1,line+2,line+3,line+4],1:]
        avg_backscatter = emp_subset.mean(axis=0)
        avg_backscatter = avg_backscatter[start:]

        m, b = np.polyfit(length[(start + 1):(len(length))], avg_backscatter, 1)
        line_statistics_1['Mult. Line Slope of Trendline'] = [m]
        line_statistics_1['Mult. Line y-int of Trendline'] = [b]
        line_statistics_1['Mult. Line Mean'] = [round(np.mean(avg_backscatter), 2)]
        line_statistics_1['Mult. Line Standard Deviation'] = [round(np.std(avg_backscatter), 2)]
        line_statistics_1['Mult. Line Range'] = [round(np.ptp(avg_backscatter), 2)]

        # average across the range
        line_data = line_data.rolling(5,axis=0).mean()
        rol_avg_data = line_data.tolist()
        rol_avg_data = rol_avg_data[start:]
        line_statistics_1['Rolling Avg. Mean'] = [round(np.mean(rol_avg_data), 2)]
        line_statistics_1['Rolling Avg. Standard Deviation'] = [round(np.std(rol_avg_data), 2)]
        line_statistics_1['Rolling Avg. Range'] = [round(np.ptp(rol_avg_data), 2)]

        if num == 0:
            line_statistics = line_statistics_1
        else:
            line_statistics = pd.concat([line_statistics_1, line_statistics], ignore_index=True)

        num = num + 1

    # Corrects index to the right range of numbers
    line_statistics.set_index('Line Number', inplace=True)

    # forms sepereate dataframes for each of the fids
    if hi == 0:
        line_statistics_2 = line_statistics
        line_statistics_2 = line_statistics_2.sort_index(axis=1, ascending=True)
        line_statistics_2 = line_statistics_2.iloc[::-1]
        #Theo_Backscatter_2 = Theo_Backscatter_1
        name_2 = name
    elif hi == 1:
        line_statistics_3 = line_statistics
        line_statistics_3 = line_statistics_3.sort_index(axis=1, ascending=True)
        line_statistics_3 = line_statistics_3.iloc[::-1]
        #Theo_Backscatter_3 = Theo_Backscatter_1
        name_3 = name
    elif hi == 2:
        line_statistics_4 = line_statistics
        line_statistics_4 = line_statistics_4.sort_index(axis=1, ascending=True)
        line_statistics_4 = line_statistics_4.iloc[::-1]
        #Theo_Backscatter_4 = Theo_Backscatter_1
        name_4 = name
    elif hi == 3:
        line_statistics_5 = line_statistics
        line_statistics_5 = line_statistics_5.sort_index(axis=1, ascending=True)
        line_statistics_5 = line_statistics_5.iloc[::-1]
        #Theo_Backscatter_5 = Theo_Backscatter_1
        name_5 = name
    else:
        line_statistics_6 = line_statistics
        line_statistics_6 = line_statistics_6.sort_index(axis=1, ascending=True)
        line_statistics_6 = line_statistics_6.iloc[::-1]
        #Theo_Backscatter_5 = Theo_Backscatter_1
        name_6 = name
    hi = hi + 1


# with pd.option_context('display.max_rows', None, 'display.max_columns', None):
#     print(line_statistics_4)

## THIS COMBINES DIFFERENTS FIDS TO PLOT FOR COMPARISON ACCORDING TO SPECIFIED IDENTICAL LINE REFERENCES
## NEED TO IGNORE INDEX SOMEHOW

## SECTION CALLOUT
Sections = pd.DataFrame()
loop = input('input number of trials:')
for h in range(1,loop):
    row_start = input('Enter the first line of the row:')
    row_end = input('Enter the end line of the row:')
    Sections['Starting line'] = [row_start]
    Sections['Ending line'] = [row_end]
    Sections['Section Description'] = [input('Enter the section description in '' :')]
    Sections['Mean of section'] = [np.mean(line_statistics_2.loc[row_start:row_end,'Mean'])]
    Sections['Std of section'] = [np.mean(line_statistics_2.loc[row_start:row_end,'Standard Deviation'])]
    Sections['Range of section'] = [np.mean(line_statistics_2.loc[row_start:row_end,'Range'])]
    Sections['Mean of section (mult. line)'] = [np.mean(line_statistics_2.loc[row_start:row_end,'Mult. Line Mean'])]
    Sections['Std of section (mult. line)'] = [np.mean(line_statistics_2.loc[row_start:row_end,'Mult. Line Standard Deviation'])]
    Sections['Range of section(mult. line)'] = [np.mean(line_statistics_2.loc[row_start:row_end,'Mult. Line Range'])]
    Sections['Mean of section (rolling)'] = [np.mean(line_statistics_2.loc[row_start:row_end,'Rolling Avg. Mean'])]
    Sections['Std of section (rolling)'] = [np.mean(line_statistics_2.loc[row_start:row_end,'Rolling Avg. Standard Deviation'])]
    Sections['Range of section(rolling)'] = [np.mean(line_statistics_2.loc[row_start:row_end,'Rolling Avg. Range'])]

with pd.option_context('display.max_rows', None, 'display.max_columns', None):
    print(Sections)




#plot = plt.figure(1)
# mean_1 = plt.plot(line_statistics_2.loc[250:1850,'Line Number'].tolist(),line_statistics_2.loc[250:1850,'Mean'].tolist(),'b-') #250:1850
# mean_2 = plt.plot(line_statistics_3.loc[900:2500,'Line Number'].tolist(),line_statistics_3.loc[900:2500,'Mean'].tolist(),'r-') #900:2500
# mean_3 = plt.plot(line_statistics_4.loc[700:2300,'Line Number'].tolist(),line_statistics_4.loc[700:2300,'Mean'].tolist(),'g-') #700:2300
# mean_4 = plt.plot(line_statistics_5.loc[1100:2700,'Line Number'].tolist(),line_statistics_5.loc[1100:2700,'Mean'].tolist(),'k-')

# # Piankatank line references
# mean_1 = plt.plot(np.arange(0, 1601, 1).tolist(), line_statistics_2.loc[250:1850,'Mean'].tolist(),'b-') #250:1850
# mean_2 = plt.plot(np.arange(0, 1601, 1).tolist(), line_statistics_3.loc[900:2500,'Mean'].tolist(),'r-') #900:2500
# std_1 = plt.plot(np.arange(0, 1601, 1).tolist(), line_statistics_2.loc[250:1850,'Standard Deviation'].tolist(),'g-') #700:2300
# std_2 = plt.plot(np.arange(0, 1601, 1).tolist(), line_statistics_3.loc[900:2500,'Standard Deviation'].tolist(),'k-') #1100:2700
# mean_3 = plt.plot(np.arange(0, 1601, 1).tolist(), line_statistics_4.loc[700:2300,'Mean'].tolist(),'g-') #700:2300
# mean_4 = plt.plot(np.arange(0, 1601, 1).tolist(), line_statistics_5.loc[1125:2725,'Mean'].tolist(),'k-') #1100:2700

# # York line references
# #mean_1 = plt.plot(np.arange(0, 2000, 1).tolist(), line_statistics_2.loc[50:2049,'Mean'].tolist(),'b-') #250:1850
# avg_mean_1 = plt.plot(np.arange(0, 2000, 1).tolist(), line_statistics_2.loc[50:2049,'Mult. Line Mean'].tolist(),'r-') #900:2500
# #std_1 = plt.plot(np.arange(0, 2000, 1).tolist(), line_statistics_2.loc[50:2049,'Standard Deviation'].tolist(),'g-') #700:2300
# avgstd_1 = plt.plot(np.arange(0, 2000, 1).tolist(), line_statistics_2.loc[50:2049,'Mult. Line Standard Deviation'].tolist(),'k-') #1100:2700
# #mean_2 = plt.plot(np.arange(0, 2000, 1).tolist(), line_statistics_3.loc[50:2049,'Mean'].tolist(),'r-') #900:2500
# #std_2 = plt.plot(np.arange(0, 2000, 1).tolist(), line_statistics_3.loc[50:2049,'Standard Deviation'].tolist(),'k-') #1100:2700
# #mean_3 = plt.plot(np.arange(0, 2000, 1).tolist(), line_statistics_4.loc[50:2049,'Mean'].tolist(),'g-') #700:2300
# #mean_4 = plt.plot(np.arange(0, 2000, 1).tolist(), line_statistics_5.loc[50:2049,'Mean'].tolist(),'k-') #1100:2700

# NH line references
#mean_1 = plt.plot(np.arange(0, 1400, 1).tolist(), line_statistics_2.loc[50:1449,'Mean'].tolist(),'b-')
#avg_mean_1 = plt.plot(np.arange(0, 1400, 1).tolist(), line_statistics_2.loc[50:1449,'Mult. Line Mean'].tolist(),'r-')
#std_1 = plt.plot(np.arange(0, 1400, 1).tolist(), line_statistics_2.loc[50:1449,'Standard Deviation'].tolist(),'g-')
#avgstd_1 = plt.plot(np.arange(0, 1400, 1).tolist(), line_statistics_2.loc[50:1449,'Mult. Line Standard Deviation'].tolist(),'k-')
#mean_2 = plt.plot(np.arange(0, 1400, 1).tolist(), line_statistics_3.loc[50:1449,'Mean'].tolist(),'r-') #900:2500
#std_2 = plt.plot(np.arange(0, 1400, 1).tolist(), line_statistics_3.loc[50:1449,'Standard Deviation'].tolist(),'k-') #1100:2700
#mean_3 = plt.plot(np.arange(0, 2000, 1).tolist(), line_statistics_4.loc[50:2049,'Mean'].tolist(),'g-') #700:2300
#mean_4 = plt.plot(np.arange(0, 2000, 1).tolist(), line_statistics_5.loc[50:2049,'Mean'].tolist(),'k-') #1100:2700

# # NH Gain comparison set #1 #Adams site 1
# mean_1 = plt.plot(np.arange(0, 201, 1).tolist(), line_statistics_2.loc[1180:1380,'Mult. Line Mean'].tolist(),'b-')
# mean_2 = plt.plot(np.arange(0, 201, 1).tolist(), line_statistics_3.loc[1770:1970,'Mult. Line Mean'].tolist(),'r-')
# mean_3 = plt.plot(np.arange(0, 201, 1).tolist(), line_statistics_4.loc[990:1190,'Mult. Line Mean'].tolist(),'g-')
# mean_4 = plt.plot(np.arange(0, 201, 1).tolist(), line_statistics_5.loc[1680:1880,'Mult. Line Mean'].tolist(),'k-')
# mean_5 = plt.plot(np.arange(0, 201, 1).tolist(), line_statistics_6.loc[540:740,'Mult. Line Mean'].tolist(),'y-')
# # NH plot gain vs. mean dB
# plot2 = plt.figure(2)
# gain_1 = plt.plot(line_statistics_2.loc[1180:1185,'Output Gain [dB]'].tolist(), line_statistics_2.loc[1180:1185,'Mult. Line Mean'].tolist(),'b.')
# gain_2 = plt.plot(line_statistics_3.loc[1770:1775,'Output Gain [dB]'].tolist(), line_statistics_3.loc[1770:1775,'Mult. Line Mean'].tolist(),'r.')
# gain_3 = plt.plot(line_statistics_4.loc[990:995,'Output Gain [dB]'].tolist(), line_statistics_4.loc[990:995,'Mult. Line Mean'].tolist(),'g.')
# gain_4 = plt.plot(line_statistics_5.loc[1680:1685,'Output Gain [dB]'].tolist(), line_statistics_5.loc[1680:1685,'Mult. Line Mean'].tolist(),'k.')
# gain_5 = plt.plot(line_statistics_6.loc[540:545,'Output Gain [dB]'].tolist(), line_statistics_6.loc[540:545,'Mult. Line Mean'].tolist(),'y.')

# ## NH Gain comparison set #2 # WOODY
# mean_1 = plt.plot(np.arange(0, 501, 1).tolist(), line_statistics_2.loc[40:540,'Mult. Line Mean'].tolist(),'b-')
# mean_2 = plt.plot(np.arange(0, 501, 1).tolist(), line_statistics_3.loc[345:845,'Mult. Line Mean'].tolist(),'r-')
# mean_3 = plt.plot(np.arange(0, 501, 1).tolist(), line_statistics_4.loc[1004:1504,'Mult. Line Mean'].tolist(),'g-')
# mean_4 = plt.plot(np.arange(0, 501, 1).tolist(), line_statistics_5.loc[360:860,'Mult. Line Mean'].tolist(),'k-')
# #mean_5 = plt.plot(np.arange(0, 201, 1).tolist(), line_statistics_6.loc[540:740,'Mult. Line Mean'].tolist(),'y-')
# # NH plot gain vs. mean dB
# plot2 = plt.figure(2)
# gain_1 = plt.plot(line_statistics_2.loc[240:245,'Applied % Gain'].tolist(), line_statistics_2.loc[240:245,'Mult. Line Mean'].tolist(),'b.')
# gain_2 = plt.plot(line_statistics_3.loc[545:550,'Applied % Gain'].tolist(), line_statistics_3.loc[545:550,'Mult. Line Mean'].tolist(),'r.')
# gain_3 = plt.plot(line_statistics_4.loc[1204:1209,'Applied % Gain'].tolist(), line_statistics_4.loc[1204:1209,'Mult. Line Mean'].tolist(),'g.')
# gain_4 = plt.plot(line_statistics_5.loc[560:565,'Applied % Gain'].tolist(), line_statistics_5.loc[560:565,'Mult. Line Mean'].tolist(),'k.')

## NH Gain comparison set #3 # ELIOT
mean_1 = plt.plot(np.arange(0, 501, 1).tolist(), line_statistics_2.loc[250:750,'Mult. Line Mean'].tolist(),'b-')
mean_2 = plt.plot(np.arange(0, 501, 1).tolist(), line_statistics_3.loc[785:1285,'Mult. Line Mean'].tolist(),'r-')
mean_3 = plt.plot(np.arange(0, 501, 1).tolist(), line_statistics_4.loc[795:1295,'Mult. Line Mean'].tolist(),'g-')
mean_4 = plt.plot(np.arange(0, 501, 1).tolist(), line_statistics_5.loc[1515:2015,'Mult. Line Mean'].tolist(),'k-')
mean_5 = plt.plot(np.arange(0, 201, 1).tolist(), line_statistics_6.loc[540:740,'Mult. Line Mean'].tolist(),'y-')
# NH plot gain vs. mean dB
plot2 = plt.figure(2)
gain_1 = plt.plot(line_statistics_2.loc[240:245,'Applied % Gain'].tolist(), line_statistics_2.loc[240:245,'Mult. Line Mean'].tolist(),'b.')
gain_2 = plt.plot(line_statistics_3.loc[545:550,'Applied % Gain'].tolist(), line_statistics_3.loc[545:550,'Mult. Line Mean'].tolist(),'r.')
gain_3 = plt.plot(line_statistics_4.loc[1204:1209,'Applied % Gain'].tolist(), line_statistics_4.loc[1204:1209,'Mult. Line Mean'].tolist(),'g.')
gain_4 = plt.plot(line_statistics_5.loc[560:565,'Applied % Gain'].tolist(), line_statistics_5.loc[560:565,'Mult. Line Mean'].tolist(),'k.')

## BANDWIDTH COMP
## Adams point, B1
# mean_1 = plt.plot(np.arange(0, 301, 1).tolist(), line_statistics_2.loc[123:423,'Mult. Line Mean'].tolist(),'b-')
# mean_2 = plt.plot(np.arange(0, 301, 1).tolist(), line_statistics_3.loc[394:694,'Mult. Line Mean'].tolist(),'r-')
# mean_3 = plt.plot(np.arange(0, 301, 1).tolist(), line_statistics_4.loc[1179:1479,'Mult. Line Mean'].tolist(),'g-')
## WOODY, B2
# mean_1 = plt.plot(np.arange(0, 301, 1).tolist(), line_statistics_2.loc[1592:1892,'Mult. Line Mean'].tolist(),'b-')
# mean_2 = plt.plot(np.arange(0, 301, 1).tolist(), line_statistics_3.loc[726:1026,'Mult. Line Mean'].tolist(),'r-')
# mean_3 = plt.plot(np.arange(0, 301, 1).tolist(), line_statistics_4.loc[820:1120,'Mult. Line Mean'].tolist(),'g-')

## FREQUENCY COMP
## Adams point, F1
# mean_1 = plt.plot(np.arange(0, 501, 1).tolist(), line_statistics_2.loc[179:679,'Mult. Line Mean'].tolist(),'b-')
# mean_2 = plt.plot(np.arange(0, 501, 1).tolist(), line_statistics_3.loc[795:1295,'Mult. Line Mean'].tolist(),'r-')
# mean_3 = plt.plot(np.arange(0, 501, 1).tolist(), line_statistics_4.loc[123:623,'Mult. Line Mean'].tolist(),'g-')
# # Frequency vs mean DB
# plot2 = plt.figure(2)
# freq_1 = plt.plot(np.full(21,900).tolist(), line_statistics_2.loc[179:199,'Mult. Line Mean'].tolist(),'b.')
# freq_2 = plt.plot(np.full(21,1100).tolist(), line_statistics_3.loc[795:815,'Mult. Line Mean'].tolist(),'r.')
# freq_3 = plt.plot(np.full(21,1000).tolist(), line_statistics_4.loc[123:143,'Mult. Line Mean'].tolist(),'g.')
## WOODY, F2
# mean_1 = plt.plot(np.arange(0, 501, 1).tolist(), line_statistics_2.loc[726:1226,'Mult. Line Mean'].tolist(),'b-')
# mean_2 = plt.plot(np.arange(0, 501, 1).tolist(), line_statistics_3.loc[1174:1674,'Mult. Line Mean'].tolist(),'r-')
# mean_3 = plt.plot(np.arange(0, 501, 1).tolist(), line_statistics_4.loc[1430:1930,'Mult. Line Mean'].tolist(),'g-')
# Frequency vs mean DB
# plot2 = plt.figure(2)
# freq_1 = plt.plot(np.full(21,900).tolist(), line_statistics_2.loc[726:746,'Mult. Line Mean'].tolist(),'b.')
# freq_2 = plt.plot(np.full(21,1100).tolist(), line_statistics_3.loc[79:815,'Mult. Line Mean'].tolist(),'r.')
# freq_3 = plt.plot(np.full(21,1000).tolist(), line_statistics_4.loc[123:143,'Mult. Line Mean'].tolist(),'g.')
## PIANKATANK, F3
# mean_1 = plt.plot(np.arange(0, 501, 1).tolist(), line_statistics_2.loc[687:1187,'Mult. Line Mean'].tolist(),'b-')
# mean_2 = plt.plot(np.arange(0, 501, 1).tolist(), line_statistics_3.loc[227:727,'Mult. Line Mean'].tolist(),'r-')
# mean_3 = plt.plot(np.arange(0, 501, 1).tolist(), line_statistics_4.loc[1100:1600,'Mult. Line Mean'].tolist(),'g-')
# Frequency vs mean DB
# plot2 = plt.figure(2)
# freq_1 = plt.plot(np.full(21,900).tolist(), line_statistics_2.loc[726:746,'Mult. Line Mean'].tolist(),'b.')
# freq_2 = plt.plot(np.full(21,1100).tolist(), line_statistics_3.loc[79:815,'Mult. Line Mean'].tolist(),'r.')
# freq_3 = plt.plot(np.full(21,1000).tolist(), line_statistics_4.loc[123:143,'Mult. Line Mean'].tolist(),'g.')

### RANGE COMP
## PINAKATANK R1
# mean_1 = plt.plot(np.arange(0, 501, 1).tolist(), line_statistics_2.loc[1110:1610,'Mult. Line Mean'].tolist(),'b-')
# mean_2 = plt.plot(np.arange(0, 501, 1).tolist(), line_statistics_3.loc[892:1392,'Mult. Line Mean'].tolist(),'r-')
# mean_3 = plt.plot(np.arange(0, 501, 1).tolist(), line_statistics_4.loc[926:1426,'Mult. Line Mean'].tolist(),'g-')
# mean_4 = plt.plot(np.arange(0, 501, 1).tolist(), line_statistics_5.loc[227:727,'Mult. Line Mean'].tolist(),'k-')
## YORK SITE 329 R2
# mean_1 = plt.plot(np.arange(0, 501, 1).tolist(), line_statistics_2.loc[70:570,'Mult. Line Mean'].tolist(),'b-')
# mean_2 = plt.plot(np.arange(0, 501, 1).tolist(), line_statistics_3.loc[46:546,'Mult. Line Mean'].tolist(),'r-')
# mean_3 = plt.plot(np.arange(0, 501, 1).tolist(), line_statistics_4.loc[680:1180,'Mult. Line Mean'].tolist(),'g-')
# mean_4 = plt.plot(np.arange(0, 501, 1).tolist(), line_statistics_5.loc[149:649,'Mult. Line Mean'].tolist(),'k-')
# ## ADAMS SITE
# mean_1 = plt.plot(np.arange(0, 501, 1).tolist(), line_statistics_2.loc[183:683,'Mult. Line Mean'].tolist(),'b-')
# mean_2 = plt.plot(np.arange(0, 501, 1).tolist(), line_statistics_3.loc[253:753,'Mult. Line Mean'].tolist(),'r-')
# mean_3 = plt.plot(np.arange(0, 501, 1).tolist(), line_statistics_4.loc[540:1040,'Mult. Line Mean'].tolist(),'g-')
## YORK SITE GOODWIN R2
# mean_1 = plt.plot(np.arange(0, 501, 1).tolist(), line_statistics_2.loc[533:1033,'Mult. Line Mean'].tolist(),'b-')
# mean_2 = plt.plot(np.arange(0, 501, 1).tolist(), line_statistics_3.loc[910:1410,'Mult. Line Mean'].tolist(),'r-')
# mean_3 = plt.plot(np.arange(0, 501, 1).tolist(), line_statistics_4.loc[943:1443,'Mult. Line Mean'].tolist(),'g-')
# mean_4 = plt.plot(np.arange(0, 501, 1).tolist(), line_statistics_5.loc[1526:2026,'Mult. Line Mean'].tolist(),'k-')
#
# ### COMPARISON ACROSS MULTIPLE SITES
# mean_1 = plt.plot(np.arange(0, 1601, 1).tolist(), line_statistics_2.loc[10:1610,'Mult. Line Mean'].tolist(),'b-')
# mean_2 = plt.plot(np.arange(0, 1601, 1).tolist(), line_statistics_3.loc[10:1610,'Mult. Line Mean'].tolist(),'r-')
# mean_3 = plt.plot(np.arange(0, 1601, 1).tolist(), line_statistics_4.loc[10:1610,'Mult. Line Mean'].tolist(),'g-')
# mean_4 = plt.plot(np.arange(0, 1601, 1).tolist(), line_statistics_5.loc[10:1610,'Mult. Line Mean'].tolist(),'k-')
# # standev_1 = plt.plot(np.arange(0, 1601, 1).tolist(), line_statistics_2.loc[10:1610,'Mult. Line Standard Deviation'].tolist(),'g-')
# # standev_2 = plt.plot(np.arange(0, 1601, 1).tolist(), line_statistics_3.loc[10:1610,'Mult. Line Standard Deviation'].tolist(),'k-')
#
#
#
# #avg_mean_1 = plt.plot(np.arange(0, 1400, 1).tolist(), line_statistics_2.loc[50:1449,'Mult. Line Mean'].tolist(),'r-')
# #std_1 = plt.plot(np.arange(0, 1400, 1).tolist(), line_statistics_2.loc[50:1449,'Standard Deviation'].tolist(),'g-')
# #avgstd_1 = plt.plot(np.arange(0, 1400, 1).tolist(), line_statistics_2.loc[50:1449,'Mult. Line Standard Deviation'].tolist(),'k-')
# #mean_2 = plt.plot(np.arange(0, 1400, 1).tolist(), line_statistics_3.loc[50:1449,'Mean'].tolist(),'r-') #900:2500
# #std_2 = plt.plot(np.arange(0, 1400, 1).tolist(), line_statistics_3.loc[50:1449,'Standard Deviation'].tolist(),'k-') #1100:2700
# #mean_3 = plt.plot(np.arange(0, 2000, 1).tolist(), line_statistics_4.loc[50:2049,'Mean'].tolist(),'g-') #700:2300
# #mean_4 = plt.plot(np.arange(0, 2000, 1).tolist(), line_statistics_5.loc[50:2049,'Mean'].tolist(),'k-') #1100:2700
#
#
blue_patch = mpatches.Patch(color='blue', label=f'Mult. line mean of {name_2} R 7.5')
red_patch = mpatches.Patch(color='red', label=f'Mult. line mean of {name_3} R 10')
green_patch = mpatches.Patch(color='green', label=f'Mult. line mean of {name_4} R 15')
black_patch = mpatches.Patch(color='black', label=f'Mult. line mean of {name_5} R 25')
plt.ylabel('Mean Backscatter [dB]')
plt.xlabel('Pings')
# #yellow_patch = mpatches.Patch(color='yellow', label=f'Mult. line mean of {name_6}')
# blue_patch = mpatches.Patch(color='blue', label=f'Mult. line mean of {name_2}')
# red_patch = mpatches.Patch(color='red', label=f'Mult. line mean of {name_3}')
# green_patch = mpatches.Patch(color='green', label=f'Mult. line mean of {name_4}')
# black_patch = mpatches.Patch(color='black', label=f'Mult. line mean of {name_5}')
# # green_patch = mpatches.Patch(color='green', label=f'Mult. line std of {name_2}')
# # black_patch = mpatches.Patch(color='black', label=f'Mult. line std of {name_3}')
# #red_patch = mpatches.Patch(color='red', label=name_3)
# # green_patch = mpatches.Patch(color='green', label=f'standard dev. of {name_2}')
# #black_patch = mpatches.Patch(color='black', label=f'standard dev. of {name_3}')
# #green_patch = mpatches.Patch(color='green', label=name_4)
# #black_patch = mpatches.Patch(color='black', label=name_5)
plt.legend(handles=[blue_patch, red_patch, green_patch, black_patch]) #, yellow_patch])
plt.show()


# ## This section will plot ripples section (for piankatank data)
# plot2 = plt.figure(2)
# mean_1 = plt.plot(np.arange(0, 201, 1).tolist(), line_statistics_2.loc[1400:1600,'Mean'].tolist(),'b-') #250:1850
# #mean_2 = plt.plot(np.arange(0, 201, 1).tolist(), line_statistics_3.loc[500:700,'Mean'].tolist(),'r-') #900:2500
# std_1 = plt.plot(np.arange(0, 201, 1).tolist(), line_statistics_2.loc[1400:1600,'Standard Deviation'].tolist(),'g-') #700:2300
# #std_2 = plt.plot(np.arange(0, 201, 1).tolist(), line_statistics_3.loc[500:700,'Standard Deviation'].tolist(),'k-') #1100:2700
# # mean_3 = plt.plot(np.arange(0, 201, 1).tolist(), line_statistics_4.loc[300:500,'Mean'].tolist(),'g-') #700:2300
# # mean_4 = plt.plot(np.arange(0, 201, 1).tolist(), line_statistics_5.loc[750:950,'Mean'].tolist(),'k-') #1100:2700
# blue_patch = mpatches.Patch(color='blue', label=name_2)
# red_patch = mpatches.Patch(color='red', label=name_3)
# green_patch = mpatches.Patch(color='green', label=f'standard dev. of {name_2}')
# black_patch = mpatches.Patch(color='black', label=f'standard dev. of {name_3}')
# # green_patch = mpatches.Patch(color='green', label=name_4)
# # black_patch = mpatches.Patch(color='black', label=name_5)
# plt.legend(handles=[blue_patch, red_patch,  green_patch, black_patch])
# # m, b = np.polyfit(length[(start+1):(len(length))], Meas_Backscatter, 1)
# # Best_fit_line = plt.plot(length[(start+1):(len(length))],(m*(length[(start+1):(len(length))])) + b,'-m')
# plt.ylabel('Mean Backscatter [dB]')
# plt.xlabel('Pings')
# # mean_ = round(np.mean(Meas_Backscatter),2)
# # mean_ = str(mean_)
# # standev = round(np.std(Meas_Backscatter),2)
# # standev = str(standev)
# # vert_range = round(np.ptp(Meas_Backscatter),2)
# # vert_range = str(vert_range)
# # string = "".join(['Stdev: ',standev,'; Range: ',vert_range,'; Mean: ',mean_])
# # plt.figtext(.2,.9,string)
#
#
# ## This section will plot non-ripples section (for piankatank data)
# plot3 = plt.figure(3)
# # mean_1 = plt.plot(np.arange(0, 101, 1).tolist(), line_statistics_2.loc[1000:1100,'Mean'].tolist(),'b-') #250:1850
# # mean_2 = plt.plot(np.arange(0, 101, 1).tolist(), line_statistics_3.loc[1600:1700,'Mean'].tolist(),'r-') #900:2500
# # std_1 = plt.plot(np.arange(0, 101, 1).tolist(), line_statistics_2.loc[1000:1100,'Standard Deviation'].tolist(),'g-') #700:2300
# # std_2 = plt.plot(np.arange(0, 101, 1).tolist(), line_statistics_3.loc[1600:1700,'Standard Deviation'].tolist(),'k-') #1100:2700
# # mean_3 = plt.plot(np.arange(0, 101, 1).tolist(), line_statistics_4.loc[1475:1575,'Mean'].tolist(),'g-') #700:2300
# # mean_4 = plt.plot(np.arange(0, 101, 1).tolist(), line_statistics_5.loc[300:400,'Mean'].tolist(),'k-') #1100:2700
# blue_patch = mpatches.Patch(color='blue', label=name_2)
# red_patch = mpatches.Patch(color='red', label=name_3)
# green_patch = mpatches.Patch(color='green', label=f'standard dev. of {name_2}')
# black_patch = mpatches.Patch(color='black', label=f'standard dev. of {name_3}')
# # green_patch = mpatches.Patch(color='green', label=name_4)
# # black_patch = mpatches.Patch(color='black', label=name_5)
# plt.legend(handles=[blue_patch, red_patch,  green_patch, black_patch])
# # m, b = np.polyfit(length[(start+1):(len(length))], Meas_Backscatter, 1)
# # Best_fit_line = plt.plot(length[(start+1):(len(length))],(m*(length[(start+1):(len(length))])) + b,'-m')
# plt.ylabel('Mean Backscatter [dB]')
# plt.xlabel('Pings')
# # mean_ = round(np.mean(Meas_Backscatter),2)
# # mean_ = str(mean_)
# # standev = round(np.std(Meas_Backscatter),2)
# # standev = str(standev)
# # vert_range = round(np.ptp(Meas_Backscatter),2)
# # vert_range = str(vert_range)
# # string = "".join(['Stdev: ',standev,'; Range: ',vert_range,'; Mean: ',mean_])
# # plt.figtext(.2,.9,string)
# plt.show()





# ## this puts differnt line statistics for one fid on the same plot
# plot = plt.figure(1)
# mean = plt.plot(line_statistics.loc[:,'Line Number'].tolist(),line_statistics.loc[:,'Mean'].tolist(),'b-')
# stan = plt.plot(line_statistics.loc[:,'Line Number'].tolist(),line_statistics.loc[:,'Standard Deviation'].tolist(),'r-')
# #range = plt.plot(line_statistics.loc[:,'Line Number'].tolist(),line_statistics.loc[:,'Range'].tolist(),'ms')
# #y_int = plt.plot(line_statistics.loc[:,'Line Number'].tolist(),line_statistics.loc[:,'y-int of Trendline'].tolist(),'g-')
# slope = plt.plot(line_statistics.loc[:,'Line Number'].tolist(),line_statistics.loc[:,'Slope of Trendline'].tolist(),'k-')
# mult_mean = plt.plot(line_statistics.loc[:,'Line Number'].tolist(),line_statistics.loc[:,'Mult. Line Mean'].tolist(),'b--')
# mult_stan = plt.plot(line_statistics.loc[:,'Line Number'].tolist(),line_statistics.loc[:,'Mult. Line Standard Deviation'].tolist(),'r--')
# mult_slope = plt.plot(line_statistics.loc[:,'Line Number'].tolist(),line_statistics.loc[:,'Mult. Line Slope of Trendline'].tolist(),'k--')
#
# blue_patch = mpatches.Patch(color='blue', label='Mean')
# red_patch = mpatches.Patch(color='red', label='Standard Deviation')
# #mag_patch = mpatches.Patch(color='magenta', label='Range')
# #green_patch = mpatches.Patch(color='green', label='y-int of Trendline')
# black_patch = mpatches.Patch(color='black', label='slope')
# plt.legend(handles=[red_patch, blue_patch, black_patch])
# plt.show()
# # plots the empirical data and theoretical data



# ###### this section plots a certain line
# ### NEED TO FIX TO HAVE THE RIGHT START
# line = 425
#
# plot = plt.figure(1)
# measured_data = plt.plot(length[(start+1):(len(length))], Meas_Backscatter, 'bs')  # ,label='Empirical Backscatter')
# theoretical_data = plt.plot(len(Theo_Backscatter_2), Theo_Backscatter_2, 'rs')  # , label='Theoretical Backscatter')
# m, b = np.polyfit(length[(start+1):(len(length))], Meas_Backscatter, 1)
# Best_fit_line = plt.plot(length[(start+1):(len(length))],(m*(length[(start+1):(len(length))])) + b,'-m')
# plt.ylabel('Backscatter [dB]')
# plt.xlabel('Range [m]')
# red_patch = mpatches.Patch(color='red', label='Theoretical backscatter')
# blue_patch = mpatches.Patch(color='blue', label='Measured Backscatter')
# mag_patch = mpatches.Patch(color='magenta', label='Best fit line')
# plt.legend(handles=[red_patch, blue_patch, mag_patch])
# mean_ = round(np.mean(Meas_Backscatter),2)
# mean_ = str(mean_)
# standev = round(np.std(Meas_Backscatter),2)
# standev = str(standev)
# vert_range = round(np.ptp(Meas_Backscatter),2)
# vert_range = str(vert_range)
# string = "".join(['Stdev: ',standev,'; Range: ',vert_range,'; Mean: ',mean_])
# plt.figtext(.2,.9,string)
# plt.show()
#
# # print(theoretical_data)
#
# # #TVG TEST
# # plot_2 = plt.figure(2)
# # measured_data_g = plt.plot(length[1:(len(length))], Meas_Backscatter_g, 'bs')  # ,label='Measured Backscatter')
# # theoretical_data = plt.plot(x_points, Theo_Backscatter, 'rs')  # , label='Theoretical Backscatter')
# # plt.ylabel('Backscatter [dB]')
# # plt.xlabel('Range [m]')
# # plt.show()
#
#
# # AVERAGE PLOT
# avg_plot = plt.figure(2)
# plt.plot(length[(start+1):(len(length))], avg_backscatter, 'bs')
# m, b = np.polyfit(length[(start+1):(len(length))],avg_backscatter, 1)
# Best_fit_line = plt.plot(length[(start+1):(len(length))],(m*(length[(start+1):(len(length))])) + b,'-m')
# plt.ylabel('Backscatter [dB]')
# plt.xlabel('Range [m]')
# blue_patch = mpatches.Patch(color='blue', label='Measured Backscatter: Average between 7 different lines')
# mag_patch = mpatches.Patch(color='magenta', label='Best fit line')
# plt.legend(handles=[blue_patch, mag_patch])
# mean_ = round(np.mean(avg_backscatter),2)
# mean_ = str(mean_)
# standev = round(np.std(avg_backscatter),2)
# standev = str(standev)
# vert_range = round(np.ptp(avg_backscatter),2)
# vert_range = str(vert_range)
# string = "".join(['Stdev: ',standev,'; Range: ',vert_range,'; Mean: ',mean_])
# plt.figtext(.2,.9,string)
#
# # ROLLING AVERAGE PLOT
# rol_plot = plt.figure(3)
# plt.plot(length[(start+1):(len(length))], rol_avg_data , 'bs')
# plt.ylabel('Backscatter [dB]')
# plt.xlabel('Range [m]')
# blue_patch = mpatches.Patch(color='blue', label='Measured Backscatter: Rolling Average down range')
# plt.legend(handles=[blue_patch])
# mean_ = round(np.mean(rol_avg_data),2)
# mean_ = str(mean_)
# standev = round(np.std(rol_avg_data),2)
# standev = str(standev)
# vert_range = round(np.ptp(rol_avg_data),2)
# vert_range = str(vert_range)
# string = "".join(['Stdev: ',standev,'; Range: ',vert_range,'; Mean: ',mean_])
# plt.figtext(.2,.9,string)


### EXPORT DATAFRAMES
# string = "".join([file_location ,'\stats_2.csv'])
# line_statistics_2.to_csv(string)
# string = "".join([file_location ,'\stats_3.csv'])
# line_statistics_3.to_csv(string)
# string = "".join([file_location ,'\stats_4.csv'])
# line_statistics_4.to_csv(string)