# Copyright <2022> <Elizabeth Q Smith>
# Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files
# (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense,
# and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

# The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
# DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
# OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

import numpy as np
import os
import pandas as pd
import time
import sys

# INSERT FILE LOCATION & FILE NAME -- This will be the folder where the Sonar data, settings and images are exported.
# file_location = 'C:/Users/lizqs/Documents/Research Grad School/Field Data/Piankatank-2'
# os.chdir(file_location)
# print(os.listdir())
#fid = 'Oct26_14_55_03.smb' #for sonar_data
#fid = 'Oct26_15_24_29.smb' #for sonar_data2
#fid = 'Oct26,2020,15-15-20.smb'
#fid = 'Oct26,2020,15-04-11.smb'
#fid = 'Oct26,2020,15-09-23.smb'
#fid = 'Oct26,2020,15-19-57.smb'
#fid = 'Oct26,2020,15-15-20.smb'
#fid = 'Oct26,2020,15-04-11.smb'
#fid = 'Oct26,2020,15-19-57.smb'
#fid = 'Oct26,2020,15-34-59.smb'
#fid = 'Oct26,2020,15-39-57.smb'
# fid = 'Oct26,2020,15-45-25.smb'
# fid = 'Oct26,2020,15-49-47.smb'


# file_location = 'C:/Users/lizqs/Documents/Research Grad School/Field Data/York 2021/July 20th/Sidescan'
# os.chdir(file_location)
#fid = 'Goodwin_337_7.5.smb'
#fid = 'Goodwin_337_10.smb'
#fid = 'Goodwin_337_15.smb'
# fid = 'Goodwin_337_25.smb'
# fid = 'Goodwin_338_10.smb'
# fid = 'Goodwin_339_10.smb'

file_location = 'C:/Users/lizqs/Documents/Research Grad School/Field Data/York 2021/July 19th/Sidescan'
os.chdir(file_location)
# fid = 'Jul19_2021_Site329_7.5.smb' # SaraCreek
# fid = 'Jul19_2021_Site330_7.5.smb' # SaraCreek
# fid = 'Jul19_2021_Site331_7.5.smb' #SaraCreek
fid = 'Jul19_2021_Site329_10.smb' # SaraCreek
# fid = 'Jul19_2021_Site329_15.smb' # SaraCreek
# fid = 'Jul19_2021_Site329_25.smb' # SaraCreek
# fid = 'Jul19_2021_Site330_10.smb'
# fid = 'Jul19_2021_Site331_10.smb'


## Comparison set #G1 #B1 #F1
# file_location = 'C:/Users/lizqs/Documents/Research Grad School/Field Data/New Hampshire/Adams_Pt_8_6'
# os.chdir(file_location)
#fid = 'Adams_site1_40gain_75_Wide.smb'
#fid = 'Adams_site1_50gain_75.smb'
#fid = 'Adams_site1_60gain_75.smb'
#fid = 'Adams_site1_75gain_75.smb'
#fid = 'Adams_site1_90gain_75.smb'
#fid = 'Adams_site1_40gain_75_Med.smb'
#fid = 'Adams_site1_40gain_75_Narr.smb'
#fid = 'Adams_site1_40gain_75_Wide.smb'
#fid = 'Adams_site1_40gain_75_900.smb'
#fid = 'Adams_site1_40gain_75_1100.smb'
#fid = 'Adams_site1_40gain_75_Med.smb'
# fid = 'Adams_site1_90gain_10.smb'
#fid = 'Adams_site1_90gain_15.smb'
#fid = 'Adams_site1_90gain_25.smb'
#fid = 'Adams_site1_40gain_10.smb'


## comparison set #G2 #B2 WOODY
# file_location = 'C:/Users/lizqs/Documents/Research Grad School/Field Data/New Hampshire/Woody_Adams_8_6'
# os.chdir(file_location)
#fid = 'Woody_Adams_40gain_75.smb'
#fid = 'Woody_Adams_50gain_75.smb'
#fid = 'Woody_Adams_60gain_75.smb'
#fid = 'Woody_Adams_75gain_75.smb'
#fid = 'Woody_Adams_90gain_75_Narr.smb'
#fid = 'Woody_Adams_90gain_75_Med.smb'
#fid = 'Woody_Adams_90gain_75.smb'
#fid = 'Woody_Adams_90gain_75_Med_900.smb'
#fid = 'Woody_Adams_90gain_75_Med_1100.smb'
# fid = 'Woody_Adams_90gain_10.smb'
# fid = 'Woody_Adams_90gain_15.smb'

## comparison set #3 ELIOT
# file_location = 'C:/Users/lizqs/Documents/Research Grad School/Field Data/New Hampshire/Eliot site'
# os.chdir(file_location)
#fid = 'Elliot_50gain_75.smb'
#fid = 'Elliot_60gain_75.smb'
#fid = 'Elliot_75gain_75.smb'
#fid = 'Elliot_90gain_75.smb'
#fid = 'Elliot_40gain_10_900.smb'
#fid = 'Elliot_40gain_10_1100.smb'
#fid = 'Elliot_40gain_10.smb'
#fid = 'Elliot_90gain_10_med.smb'

# file_location = 'C:/Users/lizqs/Documents/Research Grad School/Field Data/New Hampshire/Adams_8_7'
# os.chdir(file_location)
# fid = 'Adams_8_7_40gain_75.smb'
# fid = 'Adams_8_7_90gain_75.smb'
# fid = 'Adams_8_7_40gain_15.smb'
# fid = 'Adams_8_7_90gain_20.smb'


# reads data into dataframe
data = np.fromfile(fid, dtype='<B', count=-1, sep='')
df = pd.DataFrame(data)

# DATA TYPES IN SMB FILE and letters: (1 byte = 8 bit)
# char - 1 byte character; code 'c'
# int8 - 1 byte signed integer; code 'b'
# uint8 - 1 byte unsigned integer; code 'B'
# uint16 - 2 byte unsigned integer; code 'H' 'u2'
# int16 - 2 byte signed integer; code 'h' 'i2'
# uint32 - 4 byte unsigned integer; code 'I' 'u4'
# int32 - 4 byte signed integer; code 'i' 'i4'


# TUPLE FORM - BINARY TUPLE HEADER
# 1 Sync (H) = 32768; x8000 always beings with this value
# 2 SourceType (H)
# 3 SourceID (H)
# 4 DataType (H) - used to determine which data set
# 5 DataTime (I)
# 6 DataSize1 (H) - size of data in bytes (excludes header)
# 7 Data_Place is the location within the main data file
# relabel columns
df.columns = ['Main_data']

#This creates a subframe with all of the positions of the sync values
sync1 = df.index[(df['Main_data'] == 128)].tolist()
sync1[:] = [sync1 - 1 for sync1 in sync1]
sync2 = df.index[(df['Main_data'] == 0)].tolist()
sync_set = set(sync1).intersection(set(sync2))
sync = sorted(list(sync_set))

counter = 0

# opens file in binary
f = open(fid,"rb")
# LOOP! - creates Header data frame
for num in sync:
    f.seek(num)
    header = np.fromfile(f, dtype=[('Sync1', '<B'), ('Sync2', '<B'), ('Source_Type', '<H'), ('SourceID', '<H'),
                                   ('Data_Type', '<B'),
                                   ('Zero', '<B'), ('Data Time', '<I'), ('DataSize', '<H')], count=1)
    header = pd.DataFrame(header)
    # ifelse statement adds header rows each time.
    if counter == 0:
        df_header = header
    else:
        df_header = pd.concat([df_header, header], ignore_index=True)
    counter = counter + 1

# adds sync to df_header dataframe
df_header['Place'] = sync

#This creates a list of the row numbers of the sync values where the data type is 15 within df_header:
settings = df_header.index[(df_header['Data_Type'] == 15)].tolist()
count = 0
#SETTINGS DATAFRAME
for n in settings:

    # This gets the place of the Sync value for the DataType = 12
    MD_place = df_header.loc[n:(n+1),'Place']

    # This should put the marker at the beginning of the settings data (past the headers)
    f.seek(MD_place.iloc[0]+35)

    # read settings data
    settings_1 = np.fromfile(f, dtype=[('ScanStopsLeft','>h'), ('ScanStopsRight', '>h'), ('SectorLeft','>h'), ('SectorRight','>H'),
                                     ('ProfileMinThreshold','>H'), ('ProfileMaxThreshold','>H'), ('ProfileMinRange','>e'),
                                     ('Blank','>H'), ('ProfileMaxRange','>H'),
                                     ('ProfileMinWidth', '<H'),('ProfileMinGap','>H'), ('ProfileReserved','>u2'), ('BaudRate1','<u4'),
                                     ('SoundSpeedUser', '>u2'),('FutExp','<S15'), ('AutoTvg','b'),('TestTone','b'),
                                     ('MinCableGain', '>u2'),('MaxCableGain','>u2'), ('DualTransmitRatio','b'), ('TiltSectorHeading','<H'),
                                     ('GainShiftFactor', 'b'),('OversamplingFrequencyFactor','b'), ('AssociationFlag1','<H'), ('AssociationFlag2','<H'),
                                     ('HiResSampAcquisFactor', 'b'),('HardwareSyncMode','b'), ('Bandwidth','b'),('SectorHeading','>H'),
                                     ('SectorWidth', '<H'),('HighFrequencySampRate','<I'), ('StepSize','<e'), ('HeadAngle','<H'),
                                     ('SampRate', '<H'),('SampCount','<H'), ('SampDelay','<H'), ('Range','<H'),
                                     ('Gain', '<H'),('PulseLength','<H'), ('MultiPingCount','<H'), ('StepAck','b'),
                                     ('CommID', 'b'),('Paused','b'), ('ImageProfMode','b'), ('TransmitterOn', 'b'),
                                     ('XDCorientation', 'b'),('DisplayMode','b'), ('ZoomFactor','b'), ('ScanDirection','b'),
                                     ('BitsPerSample', 'b'),('UpSample','<b'), ('BeamType','<b'), ('HidPartNumber1','<H'),
                                     ('HidPartNumber2', '<H'),('HidSerialNumber','<I'), ('HidType','<I'), ('HidVersion1','<H'),
                                     ('HidVersion2', '<H'),('HidData1','<I'), ('HidData2','<I'), ('HidMaxBaudrateIn30bps','<H'),
                                     ('HidMaxMessageDataBytes', '<H'),('HidReserved','<H'), ('HidTelemetryVersion','<H'), ('HeadContName','<S36'),
                                     ('ZoomOffset', '<H'),('SoundSpeedDefault','<H'), ('HeadControllerVersion','b'), ('SyncState','b'),
                                     ('SyncMask', 'b'),('OperationMode','b'), ('TvgType','b'), ('TvgAFactor','b'),
                                     ('TvgBFactor', '<H'),('TvgCFactor','<h'), ('TvgLimit','b'), ('TiltAngle','<h'),
                                     ('CableCalibration', '<H'),('TiltMode','b'), ('TiltStepsize','b'), ('MaxTilt','<h'),
                                     ('MinTilt', '<h'),('TiltStopsLeft','<h'), ('TiltStopsRight','<h'), ('HeadJumperSeting','b'),
                                     ('HeadSoftwareVersion', '<H'),('AvailableSensors','b'), ('TrawlSensorReadInterval','b')], count=1)
    # This edits the columns according to how the settings are stored within the file
    settings_1['ScanStopsLeft'] = settings_1['ScanStopsLeft'] * .225
    settings_1['ScanStopsRight'] = settings_1['ScanStopsRight'] * .225
    settings_1['SectorLeft'] = settings_1['SectorLeft'] * .225
    settings_1['SectorRight'] = settings_1['SectorRight'] * .225
    settings_1['ProfileMinRange'] = settings_1['ProfileMinRange'] * .02
    settings_1['ProfileMaxRange'] = settings_1['ProfileMaxRange'] * .02
    settings_1['ProfileMinWidth'] = settings_1['ProfileMinWidth'] * .02
    settings_1['ProfileMinGap'] = settings_1['ProfileMinGap'] * .02
    settings_1['StepSize'] = settings_1['StepSize'] * .225
    settings_1['HeadAngle'] = settings_1['HeadAngle'] * .225
    settings_1['SectorHeading'] = settings_1['SectorHeading'] * .225
    settings_1['SectorWidth'] = settings_1['SectorWidth'] * .225
    settings_1['Range'] = settings_1['Range'] * .1
    settings_1['TiltAngle'] = settings_1['TiltAngle'] * .225
    settings_1['TiltStepsize'] = settings_1['TiltStepsize'] * .225
    settings_1['TiltStopsLeft'] = settings_1['TiltStopsLeft'] * .225
    settings_1['TiltStopsRight'] = settings_1['TiltStopsRight'] * .225
    settings_1['MaxTilt'] = settings_1['MaxTilt'] * .225
    settings_1['MinTilt'] = settings_1['MinTilt'] * .225

    # Convert to Dataframe
    settings_1 = pd.DataFrame(settings_1)

#NOTES:
    # Baud rate is not correct, the first values rounding is odd
    # Step size is not correct
    # tilt step size is not correct
    # check decimal values!! (ie step size)
    # Taken out:
        # ('ProfileNumReturns','>h'),

    # Creates new dataframe with the settings
    if count == 0:
        df_settings = settings_1
    else:
        df_settings = pd.concat([df_settings, settings_1], ignore_index=True)
    count = count + 1

# with pd.option_context('display.max_rows', 10, 'display.max_columns', None):
#     print(df_settings)

# this creates a list of the row numbers of the sync values where the data type is 12 within df_header
Sonar_place = df_header.index[(df_header['Data_Type'] == 12)].tolist()

# initialize variables
count = 0

# this loop creates a data frame with the sonar data
## SONAR DATA DATAFRAME
for n in Sonar_place:

    # This gets the place of the Sync value for the DataType = 12
    MD_place = df_header.loc[n:(n+1),'Place']

    # breaks out of loop at end of data (This misses one line of data- FYI)
    if (len(MD_place)) == 1:
        break

    # This section pulls the sonar data single bytes into a dataframe
    Sonar_data_1 = df.iloc[(MD_place.iloc[0] + 35):(MD_place.iloc[1] - 2)]
    Sonar_data_1 = Sonar_data_1.transpose()
    value = len(Sonar_data_1.columns) + 1
    # renames columns so that they start at one
    Sd1_length = np.arange(1, value, 1)
    Sonar_data_1.columns = [Sd1_length]

    # Creates new dataframe with the sonar data type
    if count == 0:
        Sonar_data = Sonar_data_1
    else:
        Sonar_data = pd.concat([Sonar_data_1, Sonar_data], ignore_index=True)

    # Creates High Frequency Header Data Frame with overload counter
    f.seek(df_header.loc[n,'Place']+14)
    High_Freq_header_1 = np.fromfile(f, dtype=[('BytesInPacket', '<H'), ('DisplayMode', '<B'), ('ScanDirection', '<B'), ('StepSize', '<H'),
                                  ('StartAngle', '<H'), ('SectorHeading', '<H'), ('Upsample', '<B'), ('BitsPerSample', '<B'),
                                  ('ZoomFactor', '<B'), ('Version', '<B'), ('SamplingRate', '<I'), ('SamplingDelay', '<H')], count=1)

    High_Freq_header_1 = pd.DataFrame(High_Freq_header_1)
    High_Freq_header_1 = High_Freq_header_1.transpose()

    # get overload counter to add to dataframe
    OverloadCounter = df.iloc[[MD_place.iloc[1] - 1]]
    OverloadCounter.columns = ['OverloadCounter']
    OverloadCounter.set_axis([0], axis = 'index',inplace=True)
    OverloadCounter = OverloadCounter.transpose()
    High_Freq_header_1 = pd.concat([High_Freq_header_1, OverloadCounter], ignore_index=False)
    High_Freq_header_1 = High_Freq_header_1.transpose()

    # Create high frequency dataframe
    if count == 0:
        High_Freq_header = High_Freq_header_1
    else:
        High_Freq_header = pd.concat([High_Freq_header_1, High_Freq_header], ignore_index=True)

    count = count + 1

# This corrects the angle data because it is written in .225ths
High_Freq_header['StepSize'] = .225 * High_Freq_header['StepSize']
High_Freq_header['StartAngle'] = .225 * High_Freq_header['StartAngle']
High_Freq_header['SectorHeading'] = .225 * High_Freq_header['SectorHeading']

# This section of code gets rid of the Nans within the dataframe
Sonar_data_col = Sonar_data.iloc[:,460]
drop = Sonar_data_col.index[Sonar_data_col[:].apply(np.isnan)].tolist()
new_drop = []
for n in drop:
    new_drop.append(int(n))
drop = new_drop
Sonar_data = Sonar_data.drop(drop) #,axis=0, inplace=True)
High_Freq_header = High_Freq_header.drop(drop)
# rearrange the index so that it doesn't skip values
indexsd = np.arange(0,len(Sonar_data),1).tolist()
indexhf = np.arange(0,len(Sonar_data),1).tolist()
Sonar_data = Sonar_data.set_axis(indexsd)
High_Freq_header = High_Freq_header.set_axis(indexhf)

import matplotlib
import matplotlib.pyplot as plt
import math

#this plots the long sonar image
plot2 = plt.figure(1)
sonarimg = plt.imshow(Sonar_data)
plt.ylabel('Pings')
plt.xlabel('Range')
plt.tick_params(bottom=False,labelbottom=False)
string = "".join([file_location ,'/long',fid,'.png'])
plt.savefig(string, bbox_inches='tight')

# Get theta, 1600 is 360/.225 #Assumed stepsize is .225
phi = High_Freq_header.loc[0:1599,'StartAngle'].to_numpy()
print(phi)
print(len(phi))
phi_ = np.radians(phi)

# Get range
range = df_settings.loc[0,'Range']
print(range)
spaces = len(Sonar_data.columns)
#create array of even steps...
r_ = np.arange(0,range,(range/spaces))

# gets the values for the data
Sonar_data_2 = Sonar_data.iloc[0:1600, :].to_numpy()
values = Sonar_data_2

# method to plot as polar
r, phi = np.meshgrid(r_, phi_)
x_grid = r * np.cos(phi)
y_grid = r* np.sin(phi)

# gridlines for polar imageplot1 = plt.figure(2)
polarimg = plt.pcolormesh(x_grid, y_grid, values)
plt.ylabel('Range (m)')
plt.xlabel('Range (m)')
string = "".join([file_location ,'\polar',fid,'.png'])
plt.savefig(string, bbox_inches='tight')
plt.show()

# # Other method for polar (This method plots it but for some reason adds weird things on top of plot)
# fig, ax = plt.subplots(subplot_kw=dict(projection='polar'))
# ax.contourf(phi, r, values)
# plt.show()



# EXPORTS - Settings and Sonar_data used in Flow chart code
# Settings
string = "".join([file_location ,'\settings',fid,'.csv'])
df_settings.to_csv(string)
# Sonar Data
string = "".join([file_location,'\sonar_data',fid,'.csv'])
Sonar_data.to_csv(string)
# # High_Freq_header
# string = "".join([file_location,'\HighFreqHeader.csv'])
# High_Freq_header.to_csv(string)
# # Overallheader
# string = "".join([file_location,'\Header.csv'])
# df_header.to_csv(string)


